﻿using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Windows.Forms;

namespace OlXHeaderExampleCS
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("9F387D7A-8A83-4590-B14E-BC898F7E632D"), ProgId("OlXHeaderExampleCS.AddinModule")]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        public AddinModule()
        {
            InitializeComponent();
            // Please add any initialization code to the AddinInitialize event handler

            if (HostBitness == AddinExpress.MSO.ADXHostBitness.x64) HBitness = true;
        }

        private AddinExpress.MSO.ADXOlExplorerCommandBar adxOlExplorerCommandBar1;
        private AddinExpress.MSO.ADXCommandBarButton adxCommandBarButton1;
        private AddinExpress.MSO.ADXOutlookAppEvents adxOutlookEvents;
 
        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;
 
        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            this.adxOlExplorerCommandBar1 = new AddinExpress.MSO.ADXOlExplorerCommandBar(this.components);
            this.adxCommandBarButton1 = new AddinExpress.MSO.ADXCommandBarButton(this.components);
            this.adxOutlookEvents = new AddinExpress.MSO.ADXOutlookAppEvents(this.components);
            // 
            // adxOlExplorerCommandBar1
            // 
            this.adxOlExplorerCommandBar1.CommandBarName = "X-Header Toolbar";
            this.adxOlExplorerCommandBar1.CommandBarTag = "8e417fc7-e7d5-47fc-ade5-c9c20bcdfe17";
            this.adxOlExplorerCommandBar1.Controls.Add(this.adxCommandBarButton1);
            this.adxOlExplorerCommandBar1.Temporary = true;
            this.adxOlExplorerCommandBar1.UpdateCounter = 10;
            // 
            // adxCommandBarButton1
            // 
            this.adxCommandBarButton1.Caption = "Show SMTP Address";
            this.adxCommandBarButton1.ControlTag = "629f5dfe-ca6e-437d-b71b-1cf6db816620";
            this.adxCommandBarButton1.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxCommandBarButton1.Temporary = true;
            this.adxCommandBarButton1.UpdateCounter = 10;
            this.adxCommandBarButton1.Click += new AddinExpress.MSO.ADXClick_EventHandler(this.adxCommandBarButton1_Click);
            // 
            // adxOutlookEvents
            // 
            this.adxOutlookEvents.ItemSend += new AddinExpress.MSO.ADXOlItemSend_EventHandler(this.adxOutlookEvents_ItemSend);
            // 
            // AddinModule
            // 
            this.AddinName = "Outlook SMTP X-Header Example";
            this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook;

        }
        #endregion
 
        #region Add-in Express automatic code
 
        // Required by Add-in Express - do not modify
        // the methods within this region
 
        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }
 
        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }
 
        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }
 
        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

        public static new AddinModule CurrentInstance
        {
            get
            {
                return AddinExpress.MSO.ADXAddinModule.CurrentInstance as AddinModule;
            }
        }

        public Outlook._Application OutlookApp
        {
            get
            {
                return (HostApplication as Outlook._Application);
            }
        }

        private string magicGUID = "{00020386-0000-0000-C000-000000000046}";
        private bool HBitness = false;

        private void adxOutlookEvents_ItemSend(object sender, AddinExpress.MSO.ADXOlItemSendEventArgs e)
        {
            if (e.Item is Outlook._MailItem)
            {
                try
                {
                    Outlook._MailItem item = e.Item as Outlook._MailItem;
                    item.Save();
                    SetHeader(item.MAPIOBJECT, "From", "support@add-in-express.com");
                }
                catch (Exception err)
                {
                    this.ShowErrorDialog(this, err);
                }
            }
        }

        private void SetHeader(object itemObj, string headerName, string _value)
        {
            IMAPIProp mail = null;
            mail = itemObj as IMAPIProp;
            if (mail != null)
            {
                IntPtr p = IntPtr.Zero;
                IntPtr lpszStr = IntPtr.Zero;
                IntPtr propTags = IntPtr.Zero;
                IntPtr lpszValue = IntPtr.Zero;
                IntPtr lpProblems = IntPtr.Zero;
                IntPtr lpPropValue = IntPtr.Zero;
                IntPtr _mapiNameID = IntPtr.Zero;
                SPropValue propValue = new SPropValue();
                MAPINAMEID mapiNameID = new MAPINAMEID();
                try
                {
                    Guid g = new Guid(magicGUID);
                    _mapiNameID = Marshal.AllocHGlobal(Marshal.SizeOf(typeof(MAPINAMEID)));

                    p = Marshal.AllocHGlobal(Marshal.SizeOf(g));
                    Marshal.StructureToPtr(g, p, false);
                    mapiNameID.lpguid = p;
                    mapiNameID.ulKind = MAPI.MNID_STRING;
                    lpszStr = Marshal.StringToHGlobalUni(headerName);
                    mapiNameID.lpwstrName = lpszStr;
                    Marshal.StructureToPtr(mapiNameID, _mapiNameID, false);

                    if (mail.GetIDsFromNames(1, ref _mapiNameID, MAPI.MAPI_CREATE, out propTags) == MAPI.S_OK)
                    {
                        int count = Marshal.ReadInt32(propTags);
                        if (count == 1)
                        {
                            uint tag = (uint)Marshal.ReadInt32(new IntPtr(propTags.ToInt32() + 4));
                            tag = ((tag & 0xFFFF0000) | MAPI.PT_STRING8);
                            lpPropValue = Marshal.AllocHGlobal(Marshal.SizeOf(typeof(SPropValue)));
                            propValue.ulPropTag = tag;
                            propValue.dwAlignPad = 0;
                            lpszValue = Marshal.StringToHGlobalAnsi(_value);
                            propValue.Value = lpszValue.ToInt64();
                            Marshal.StructureToPtr(propValue, lpPropValue, false);
                            if (mail.SetProps(1, lpPropValue, out lpProblems) == MAPI.S_OK)
                            {
                                if (mail.SaveChanges(MAPI.KEEP_OPEN_READWRITE) == MAPI.S_OK)
                                {
                                }
                            }
                        }
                    }
                }
                finally
                {
                    if (lpszValue != IntPtr.Zero)
                        Marshal.FreeHGlobal(lpszValue);
                    if (lpPropValue != IntPtr.Zero)
                        Marshal.DestroyStructure(lpPropValue, typeof(SPropValue));
                    if (propTags != IntPtr.Zero)
                        MAPI.MAPIFreeBuffer(propTags, HBitness);
                    if (p != IntPtr.Zero)
                        Marshal.DestroyStructure(p, typeof(Guid));
                    if (lpszStr != IntPtr.Zero)
                        Marshal.FreeHGlobal(lpszStr);
                    if (_mapiNameID != IntPtr.Zero)
                        Marshal.DestroyStructure(_mapiNameID, typeof(MAPINAMEID));
                }
            }
        }

        private void adxCommandBarButton1_Click(object sender)
        {
            object itemObj = null;
            object currentItem = null;
            Outlook.MailItem mail = null;
            Outlook._Explorer explorer = null;
            Outlook.Selection selection = null;

            try
            {
                explorer = OutlookApp.ActiveExplorer();
                try
                {
                    selection = explorer.Selection;
                }
                catch
                {
                }
                if (selection != null && selection.Count > 0)
                {
                    currentItem = selection.Item(1);
                    mail = currentItem as Outlook.MailItem;
                    if (mail == null) return;

                    itemObj = mail.MAPIOBJECT;

                    string address = GetHeader(itemObj, "From");
                    if (address == String.Empty)
                        address = GetSMTPAddress(itemObj);
                    // or
                    // address = GetTransportHeader(itemObj);

                    if (address != String.Empty)
                        MessageBox.Show(address);
                }
            }
            catch (Exception err)
            {
                this.ShowErrorDialog(this, err);
            }
            finally
            {
                if (itemObj != null)
                    Marshal.ReleaseComObject(itemObj);
                if (currentItem != null)
                    Marshal.ReleaseComObject(currentItem);
                if (selection != null)
                    Marshal.ReleaseComObject(selection);
                if (explorer != null)
                    Marshal.ReleaseComObject(explorer);
            }
        }

        private string GetHeader(object itemObj, string headerName)
		{
			IMAPIProp mail = null;
			string retVal = String.Empty;

			mail = itemObj as IMAPIProp;
			if (mail != null)
			{
				IntPtr p = IntPtr.Zero;
				IntPtr lpszStr = IntPtr.Zero;
				IntPtr propTags = IntPtr.Zero;
				IntPtr lpszValue = IntPtr.Zero;
				IntPtr lpProblems = IntPtr.Zero;
				IntPtr lpPropValue = IntPtr.Zero;
				IntPtr _mapiNameID = IntPtr.Zero;
				IntPtr lpPropArray = IntPtr.Zero;
				SPropValue propValue = new SPropValue();
				MAPINAMEID mapiNameID = new MAPINAMEID();
				try
				{
					Guid g = new Guid(magicGUID);
					_mapiNameID = Marshal.AllocHGlobal(Marshal.SizeOf(typeof(MAPINAMEID)));
		
					p = Marshal.AllocHGlobal(Marshal.SizeOf(g));
					Marshal.StructureToPtr(g, p, false);
					mapiNameID.lpguid = p;
					mapiNameID.ulKind = MAPI.MNID_STRING;
					lpszStr = Marshal.StringToHGlobalUni(headerName);
					mapiNameID.lpwstrName = lpszStr;
					Marshal.StructureToPtr(mapiNameID, _mapiNameID, false);

					if (mail.GetIDsFromNames(1, ref _mapiNameID, MAPI.MAPI_CREATE, out propTags) == MAPI.S_OK)
					{
						int count = Marshal.ReadInt32(propTags);
						if (count == 1)
						{
							uint cValues = 0;
							if (mail.GetProps(propTags, MAPI.MAPI_UNICODE, out cValues, out lpPropArray) == MAPI.S_OK)
							{
								if (cValues == 1)
								{
									uint pType = (uint)(Marshal.ReadInt32(lpPropArray) & 0xFFFF);
									if (pType == MAPI.PT_ERROR)
									{
										//Marshal.ThrowExceptionForHR(Marshal.ReadInt32(lpPropArray));
									}
									else 
									{
										int strAddr = Marshal.ReadInt32(new IntPtr(lpPropArray.ToInt32() + 8));
										retVal = Marshal.PtrToStringAuto(new IntPtr(strAddr));
									}
								}
							}
						}
					}
				}
				finally
				{
					if (lpPropArray != IntPtr.Zero)
						MAPI.MAPIFreeBuffer(lpPropArray, HBitness);
					if (lpszValue != IntPtr.Zero)
						Marshal.FreeHGlobal(lpszValue);
					if (lpPropValue != IntPtr.Zero)
						Marshal.DestroyStructure(lpPropValue, typeof(SPropValue));
					if (propTags != IntPtr.Zero)
						MAPI.MAPIFreeBuffer(propTags, HBitness);
					if (p != IntPtr.Zero)
						Marshal.DestroyStructure(p, typeof(Guid));
					if (lpszStr != IntPtr.Zero)
						Marshal.FreeHGlobal(lpszStr);
					if (_mapiNameID != IntPtr.Zero)
						Marshal.DestroyStructure(_mapiNameID, typeof(MAPINAMEID));
				}
			}
			return retVal;
		}

		private string GetTransportHeader(object itemObj)
		{
			IntPtr itemPtr = IntPtr.Zero;
			string retVal = String.Empty;
			IntPtr propAddressPtr = IntPtr.Zero;

			try
			{
				itemPtr = Marshal.GetIUnknownForObject(itemObj);
				if (MAPI.HrGetOneProp(itemPtr, MAPI.PR_TRANSPORT_MESSAGE_HEADERS_A, out propAddressPtr, HBitness) == MAPI.S_OK)
				{
					IntPtr emails = IntPtr.Zero;
					SPropValue propValue = (SPropValue)Marshal.PtrToStructure(propAddressPtr, typeof(SPropValue));
					retVal = Marshal.PtrToStringAnsi(new IntPtr(propValue.Value));
				}
			}
			finally
			{
				if (propAddressPtr != IntPtr.Zero)
					MAPI.MAPIFreeBuffer(propAddressPtr, HBitness);
				if (itemPtr != IntPtr.Zero)
					Marshal.Release(itemPtr);
			}
			return retVal;
		}

		private string GetSMTPAddress(object itemObj)
		{
			IntPtr itemPtr = IntPtr.Zero;
			string retVal = String.Empty;

			try
			{
				string senderType = String.Empty;
				IntPtr propAddressTypePtr = IntPtr.Zero;

				itemPtr = Marshal.GetIUnknownForObject(itemObj);
				try
				{
					if (MAPI.HrGetOneProp(itemPtr, MAPI.PR_SENDER_ADDRTYPE, out propAddressTypePtr, HBitness) == MAPI.S_OK)
					{
						IntPtr emails = IntPtr.Zero;
						SPropValue propValue = (SPropValue)Marshal.PtrToStructure(propAddressTypePtr, typeof(SPropValue));
						senderType = Marshal.PtrToStringAnsi(new IntPtr(propValue.Value));
					}
				}
				finally
				{
					if (propAddressTypePtr != IntPtr.Zero)
						MAPI.MAPIFreeBuffer(propAddressTypePtr, HBitness);
				}

				if (senderType == "SMTP")
				{
					IntPtr propAddressPtr = IntPtr.Zero;
					try
					{
						if (MAPI.HrGetOneProp(itemPtr, MAPI.PR_SENDER_EMAIL_ADDRESS, out propAddressPtr, HBitness) == MAPI.S_OK)
						{
							SPropValue propValue = (SPropValue)Marshal.PtrToStructure(propAddressPtr, typeof(SPropValue));
							retVal = Marshal.PtrToStringAnsi(new IntPtr(propValue.Value));
						}
					}
					finally
					{
						if (propAddressPtr != IntPtr.Zero)
							MAPI.MAPIFreeBuffer(propAddressPtr, HBitness);
					}
				}
			}
			finally
			{
				if (itemPtr != IntPtr.Zero)
					Marshal.Release(itemPtr);
			}
			return retVal;
		}
	}    
}

